'=====================================================================================
'  mkc_CodeBox
'  color syntax control
'=====================================================================================
'  Created By: Marc Cramer
'  Published Date: 1/16/2003
'  Legal Copyright: Marc Cramer  1/16/2003
'=====================================================================================

Imports System
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.ComponentModel

Public Class mkc_CodeBox
	Inherits System.Windows.Forms.UserControl

#Region "Variable Declarations"
	'=========================================================================================
	' Variable Declarations...
	'=========================================================================================
	Public Enum LinePosition As Byte
		LinePosition_End = 0
		LinePosition_Front = 1
	End Enum

	Dim RTF_FirstVisibleLine As Integer
	Dim RegexKeywordList As String
	Dim CurrentPosition As Integer
	Dim StartPosition As Integer
	Dim PasteFlag As Boolean
	Dim UndoFlag As Boolean
	Dim UndoHistory As String
	Dim UndoHistoryPosition As Integer
	'=========================================================================================
	' Property Variables
	'=========================================================================================
	Dim m_Sidebar_ShowLineNumbers As Boolean = True
	Dim m_Sidebar_BackGroundColor As Color = Color.Gray
	Dim m_Sidebar_ForeColor As Color = Color.White
	Dim m_Sidebar_Brush As New SolidBrush(Color.White)
	Dim m_Sidebar_Font As Font = New Font("Verdana", 7)

	Dim m_TextEditor_NormalTextColor As Color = Color.Black
	Dim m_TextEditor_KeywordTextColor As Color = Color.Blue
	Dim m_TextEditor_CommentTextColor As Color = Color.Green
	Dim m_TextEditor_Font As Font = New Font("Verdana", 8)
	Dim m_TextEditor_KeywordList As String = ""
	Dim m_TextEditor_KeywordDelimiter As String = ""
	Dim m_TextEditor_CommentCharacter As String = ""
	Dim m_TextEditor_ColorCode As Boolean = True
#End Region

#Region "Windows Form Designer generated code "
	'=========================================================================================
	Public Sub New()
		MyBase.New()
		InitializeComponent()

		' set our screen drawing options
		SetStyle(ControlStyles.UserPaint, True)
		SetStyle(ControlStyles.AllPaintingInWmPaint, True)
		SetStyle(ControlStyles.DoubleBuffer, True)
		SetStyle(ControlStyles.ResizeRedraw, True)
	End Sub	  'New()

	'=========================================================================================
	Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
		If disposing Then
			If Not (components Is Nothing) Then
				components.Dispose()
			End If
		End If
		MyBase.Dispose(disposing)
	End Sub	  'Dispose(ByVal disposing As Boolean)
	'=========================================================================================
	'Required by the Windows Form Designer
	Private components As System.ComponentModel.IContainer
	Friend WithEvents Panel_Frame As System.Windows.Forms.Panel
	Friend WithEvents Splitter As System.Windows.Forms.Splitter
	Friend WithEvents Panel_LineNumbers As System.Windows.Forms.Panel
	Friend WithEvents RTF As System.Windows.Forms.RichTextBox
	'=========================================================================================
	Friend WithEvents RTF_Temp As System.Windows.Forms.RichTextBox
	<System.Diagnostics.DebuggerStepThrough()> _
	Private Sub InitializeComponent()
		Me.Panel_Frame = New System.Windows.Forms.Panel()
		Me.RTF = New System.Windows.Forms.RichTextBox()
		Me.Splitter = New System.Windows.Forms.Splitter()
		Me.Panel_LineNumbers = New System.Windows.Forms.Panel()
		Me.RTF_Temp = New System.Windows.Forms.RichTextBox()
		Me.Panel_Frame.SuspendLayout()
		Me.SuspendLayout()
		'
		'Panel_Frame
		'
		Me.Panel_Frame.Controls.AddRange(New System.Windows.Forms.Control() {Me.RTF, Me.Splitter, Me.Panel_LineNumbers})
		Me.Panel_Frame.Dock = System.Windows.Forms.DockStyle.Fill
		Me.Panel_Frame.Name = "Panel_Frame"
		Me.Panel_Frame.Size = New System.Drawing.Size(150, 150)
		Me.Panel_Frame.TabIndex = 6
		'
		'RTF
		'
		Me.RTF.AcceptsTab = True
		Me.RTF.AutoWordSelection = True
		Me.RTF.BorderStyle = System.Windows.Forms.BorderStyle.None
		Me.RTF.Dock = System.Windows.Forms.DockStyle.Fill
		Me.RTF.Font = New System.Drawing.Font("Verdana", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
		Me.RTF.Location = New System.Drawing.Point(34, 0)
		Me.RTF.Name = "RTF"
		Me.RTF.Size = New System.Drawing.Size(116, 150)
		Me.RTF.TabIndex = 2
		Me.RTF.Text = ""
		Me.RTF.WordWrap = False
		'
		'Splitter
		'
		Me.Splitter.BackColor = System.Drawing.SystemColors.AppWorkspace
		Me.Splitter.Location = New System.Drawing.Point(32, 0)
		Me.Splitter.Name = "Splitter"
		Me.Splitter.Size = New System.Drawing.Size(2, 150)
		Me.Splitter.TabIndex = 1
		Me.Splitter.TabStop = False
		'
		'Panel_LineNumbers
		'
		Me.Panel_LineNumbers.BackColor = System.Drawing.Color.Gray
		Me.Panel_LineNumbers.Dock = System.Windows.Forms.DockStyle.Left
		Me.Panel_LineNumbers.Font = New System.Drawing.Font("Verdana", 7.0!)
		Me.Panel_LineNumbers.Name = "Panel_LineNumbers"
		Me.Panel_LineNumbers.Size = New System.Drawing.Size(32, 150)
		Me.Panel_LineNumbers.TabIndex = 0
		'
		'RTF_Temp
		'
		Me.RTF_Temp.Font = New System.Drawing.Font("Verdana", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
		Me.RTF_Temp.Name = "RTF_Temp"
		Me.RTF_Temp.TabIndex = 7
		Me.RTF_Temp.Text = ""
		Me.RTF_Temp.Visible = False
		'
		'mkc_CodeBox
		'
		Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Panel_Frame, Me.RTF_Temp})
		Me.Name = "mkc_CodeBox"
		Me.Panel_Frame.ResumeLayout(False)
		Me.ResumeLayout(False)

	End Sub	  'InitializeComponent()
	'=========================================================================================
#End Region

#Region "Events"
	'=========================================================================================
	' Events
	'=========================================================================================
	Private Sub RTF_VScroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RTF.VScroll
		' are we showing linenumbers...if so update display
		If m_Sidebar_ShowLineNumbers = True Then
			LockUpdate(True)
			Panel_LineNumbers.Invalidate()
			LockUpdate(False)
		End If
	End Sub	  'RTF_VScroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RTF.VScroll
	'=========================================================================================
	Private Sub RTF_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RTF.SelectionChanged
		Dim CurrentFirstVisibleLine As Integer
		If RTF_FirstVisibleLine < CurrentFirstVisibleLine Then
			RTF_FirstVisibleLine = CurrentFirstVisibleLine
			' are we showing linenumbers...if so update display
			If m_Sidebar_ShowLineNumbers = True Then
				LockUpdate(True)
				Panel_LineNumbers.Invalidate()
				LockUpdate(False)
			End If
		End If
	End Sub	  'RTF_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RTF.SelectionChanged
	'=========================================================================================
	Private Sub RTF_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RTF.Resize
		' are we showing linenumbers...if so update display
		If m_Sidebar_ShowLineNumbers = True Then
			LockUpdate(True)
			Panel_LineNumbers.Invalidate()
			LockUpdate(False)
		End If
		'raise up the event
		Me.OnResize(e)
	End Sub	  'RTF_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RTF.Resize
	'=========================================================================================
	Private Sub RTF_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles RTF.KeyDown
		Dim InvalidateFlag As Boolean = False
		'reset our flags
		PasteFlag = False
		UndoFlag = False

		' special handling needed...
		If e.Control = True Then
			Select Case e.KeyCode
				Case Keys.A
					' select all
					RTF.Modified = RTF.Modified
				Case Keys.X
					' cut
					RTF.Modified = True
					InvalidateFlag = True
				Case Keys.V
					' paste
					PasteFlag = True
					RTF.Modified = True
					InvalidateFlag = True
				Case Keys.Z
					' undo
					UndoFlag = True
					RTF.Modified = True
					InvalidateFlag = True
			End Select
		Else
			' set rtf as dirty if needed
			Select Case e.KeyCode
				Case Keys.Alt, Keys.Apps, Keys.Attn, Keys.BrowserBack, Keys.BrowserFavorites, Keys.BrowserForward, Keys.BrowserHome, Keys.BrowserRefresh, Keys.BrowserSearch, Keys.BrowserStop, Keys.Cancel, Keys.Capital, Keys.CapsLock, Keys.Clear, Keys.Control, Keys.ControlKey, Keys.Crsel, Keys.D0, Keys.D1, Keys.D2, Keys.D3, Keys.D4, Keys.D5, Keys.D6, Keys.D7, Keys.D8, Keys.D9, Keys.Down, Keys.End, Keys.EraseEof, Keys.Escape, Keys.Execute, Keys.Exsel, Keys.F1, Keys.F10, Keys.F11, Keys.F12, Keys.F13, Keys.F14, Keys.F15, Keys.F16, Keys.F17, Keys.F18, Keys.F19, Keys.F2, Keys.F20, Keys.F21, Keys.F22, Keys.F23, Keys.F24, Keys.F3, Keys.F4, Keys.F5, Keys.F6, Keys.F7, Keys.F8, Keys.F9, Keys.FinalMode, Keys.HanguelMode, Keys.HangulMode, Keys.HanjaMode, Keys.Help, Keys.Home, Keys.IMEAceept, Keys.IMEConvert, Keys.IMEModeChange, Keys.IMENonconvert, Keys.Insert, Keys.JunjaMode, Keys.KanaMode, Keys.KanjiMode, Keys.KeyCode, Keys.LaunchApplication1, Keys.LaunchApplication2, Keys.LaunchMail, Keys.LButton, Keys.LControlKey, Keys.Left, Keys.LMenu, Keys.LShiftKey, Keys.LWin, Keys.MButton, Keys.MediaNextTrack, Keys.MediaPlayPause, Keys.MediaPreviousTrack, Keys.MediaStop, Keys.Menu, Keys.Modifiers, Keys.Next, Keys.NoName, Keys.None, Keys.NumLock, Keys.Pa1, Keys.PageDown, Keys.PageUp, Keys.Pause, Keys.Play, Keys.Print, Keys.PrintScreen, Keys.Prior, Keys.ProcessKey, Keys.RButton, Keys.RControlKey, Keys.Right, Keys.RMenu, Keys.RShiftKey, Keys.RWin, Keys.Scroll, Keys.Select, Keys.SelectMedia, Keys.Shift, Keys.ShiftKey, Keys.Snapshot, Keys.Up, Keys.VolumeDown, Keys.VolumeMute, Keys.VolumeUp, Keys.XButton1, Keys.XButton2, Keys.Zoom
					RTF.Modified = RTF.Modified
				Case Else
					RTF.Modified = True
			End Select
			'save the rtf for undo history
			UndoHistory = RTF.Rtf
			UndoHistoryPosition = RTF.SelectionStart
		End If

		' are we showing linenumbers...if so update display
		If m_Sidebar_ShowLineNumbers = True Then
			If e.KeyCode = Keys.Delete Or e.KeyCode = Keys.Back Or e.KeyCode = Keys.Enter Or InvalidateFlag = True Then
				LockUpdate(True)
				Panel_LineNumbers.Invalidate()
				LockUpdate(False)
			End If
		End If
		'raise up the event
		Me.OnKeyDown(e)
	End Sub	  'RTF_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles RTF.KeyDown
	'=========================================================================================
	Private Sub RTF_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles RTF.KeyPress
		'raise up the event
		Me.OnKeyPress(e)
	End Sub
	'=========================================================================================
	Private Sub RTF_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles RTF.KeyUp
		'save where we are right now and where we were
		StartPosition = CurrentPosition
		CurrentPosition = RTF.SelectionStart
		' are we supposed to color code...
		If m_TextEditor_ColorCode = True Then
			' if rtf is dirty then we need to parse it...
			If RTF.Modified = True Then
				' check to see if we are undoing previous action...
				If UndoFlag = False Then
					If PasteFlag = False Then
						' only working with current line
						ParseText(modRTF_Net.LineText(RTF))
						RTF.SelectionStart = CurrentPosition
						RTF.SelectionColor = m_TextEditor_NormalTextColor
					Else
						' something pasted so if text then parse it...
						If IsPastedText() = True Then ParsePastedText(False)
						' reset our flag
						PasteFlag = False
					End If
				Else
					' undo so set to undo history value...
					Undo()
				End If
			End If
		End If
		'raise up the event
		Me.OnKeyUp(e)
	End Sub
	'=========================================================================================
	Private Sub RTF_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTF.TextChanged
		'raise up the event
		Me.OnTextChanged(e)
	End Sub	  'RTF_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTF.TextChanged
	'=========================================================================================
	Private Sub Panel_LineNumbers_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Panel_LineNumbers.Paint
		' are we showing linenumbers...if so update display
		If m_Sidebar_ShowLineNumbers = True Then DrawLineNumber(e.Graphics, modRTF_Net.FirstVisibleLine(RTF))
	End Sub	  'Panel_LineNumbers_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Panel_LineNumbers.Paint
	'=========================================================================================
	Protected Overrides Sub OnGotFocus(ByVal e As System.EventArgs)
		RTF.Focus()
	End Sub	  'OnGotFocus(ByVal e As System.EventArgs)
	'=========================================================================================
	Private Sub Panel_Frame_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Panel_Frame.MouseEnter
		Me.OnMouseEnter(e)
	End Sub	  'Panel_Frame_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Panel_Frame.MouseEnter
	'=========================================================================================
	Private Sub Panel_Frame_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Panel_Frame.MouseLeave
		Me.OnMouseLeave(e)
	End Sub	  'Panel_Frame_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Panel_Frame.MouseLeave
	'=========================================================================================
	Private Sub Panel_Frame_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_Frame.MouseMove
		Me.OnMouseMove(e)
	End Sub	  'Panel_Frame_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_Frame.MouseMove
	'=========================================================================================
	Private Sub Splitter_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Splitter.MouseMove
		Me.OnMouseMove(e)
	End Sub	  'Splitter_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Splitter.MouseMove
	'=========================================================================================
	Private Sub Panel_LineNumbers_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Panel_LineNumbers.MouseEnter
		Me.OnMouseEnter(e)
	End Sub	  'Panel_LineNumbers_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Panel_LineNumbers.MouseEnter
	'=========================================================================================
	Private Sub Panel_LineNumbers_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_LineNumbers.MouseMove
		Me.OnMouseMove(e)
	End Sub	  'Panel_LineNumbers_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_LineNumbers.MouseMove
	'=========================================================================================
	Private Sub Panel_LineNumbers_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Panel_LineNumbers.MouseLeave
		Me.OnMouseLeave(e)
	End Sub	  'Panel_LineNumbers_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Panel_LineNumbers.MouseLeave
	'=========================================================================================
	Private Sub RTF_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTF.MouseEnter
		Me.OnMouseEnter(e)
	End Sub	  'RTF_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTF.MouseEnter
	'=========================================================================================
	Private Sub RTF_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTF.MouseLeave
		Me.OnMouseLeave(e)
	End Sub	  'RTF_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTF.MouseLeave
	'=========================================================================================
	Private Sub RTF_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles RTF.MouseMove
		Me.OnMouseMove(e)
	End Sub	  'RTF_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles RTF.MouseMove
	'=========================================================================================
	Private Sub Panel_Frame_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_Frame.MouseDown
		Me.OnMouseDown(e)
	End Sub	  'Panel_Frame_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_Frame.MouseDown
	'=========================================================================================
	Private Sub Panel_Frame_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_Frame.MouseUp
		Me.OnMouseUp(e)
	End Sub	  'Panel_Frame_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_Frame.MouseUp
	'=========================================================================================
	Private Sub Panel_LineNumbers_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_LineNumbers.MouseDown
		Me.OnMouseDown(e)
	End Sub	  'Panel_LineNumbers_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_LineNumbers.MouseDown
	'=========================================================================================
	Private Sub Panel_LineNumbers_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_LineNumbers.MouseUp
		Me.OnMouseUp(e)
	End Sub	  'Panel_LineNumbers_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel_LineNumbers.MouseUp
	'=========================================================================================
	Private Sub RTF_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles RTF.MouseDown
		Me.OnMouseDown(e)
	End Sub	  'RTF_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles RTF.MouseDown
	'=========================================================================================
	Private Sub RTF_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles RTF.MouseUp
		Me.OnMouseUp(e)
	End Sub	  'RTF_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles RTF.MouseUp
	'=========================================================================================
#End Region

#Region "Properties"
	'=========================================================================================
	' Properties
	'=========================================================================================
	<Description("Gets and sets the visibility of the line number sidebar."), Category("Line Numbering Sidebar")> _
	 Public Property Sidebar_ShowLineNumbers() As Boolean
		Get
			Return m_Sidebar_ShowLineNumbers
		End Get
		Set(ByVal Value As Boolean)
			m_Sidebar_ShowLineNumbers = Value
			If m_Sidebar_ShowLineNumbers = True Then
				Panel_LineNumbers.Visible = True
				Splitter.Visible = True
			Else
				Panel_LineNumbers.Visible = False
				Splitter.Visible = False
			End If
		End Set
	End Property	  'Sidebar_ShowLineNumbers() As Boolean
	'=========================================================================================
	<Description("Gets and sets the background color of the line number sidebar."), Category("Line Numbering Sidebar")> _
	 Public Property Sidebar_BackgroundColor() As Color
		Get
			Return m_Sidebar_BackGroundColor
		End Get
		Set(ByVal Value As Color)
			m_Sidebar_BackGroundColor = Value
			Panel_LineNumbers.BackColor = m_Sidebar_BackGroundColor
			Splitter.BackColor = m_Sidebar_BackGroundColor
		End Set
	End Property	  'Sidebar_BackgroundColor() As Color
	'=========================================================================================
	<Description("Gets and sets the font color of the line number sidebar."), Category("Line Numbering Sidebar")> _
	 Public Property Sidebar_ForeColor() As Color
		Get
			Return m_Sidebar_ForeColor
		End Get
		Set(ByVal Value As Color)
			m_Sidebar_ForeColor = Value
			Panel_LineNumbers.ForeColor = m_Sidebar_ForeColor
			m_Sidebar_Brush.Color = m_Sidebar_ForeColor
		End Set
	End Property	  'Sidebar_ForeColor() As Color
	'=========================================================================================
	<Description("Gets and sets the font of the line number sidebar."), Category("Line Numbering Sidebar")> _
	 Public Property Sidebar_Font() As Font
		Get
			Return m_Sidebar_Font
		End Get
		Set(ByVal Value As Font)
			m_Sidebar_Font = Value
			Panel_LineNumbers.Font = m_Sidebar_Font
		End Set
	End Property	  'Sidebar_Font() As Font
	'=========================================================================================
	<Description("Gets and sets the font color of the text editor for regular text."), Category("Text Editor")> _
	Public Property TextEditor_NormalTextColor() As Color
		Get
			Return m_TextEditor_NormalTextColor
		End Get
		Set(ByVal Value As Color)
			m_TextEditor_NormalTextColor = Value
			RTF.ForeColor = m_TextEditor_NormalTextColor
			RTF_Temp.ForeColor = m_TextEditor_NormalTextColor
		End Set
	End Property	  'TextEditor_NormalTextColor() As Color
	'=========================================================================================
	<Description("Gets and sets the font color of the text editor for keywords."), Category("Text Editor")> _
	Public Property TextEditor_KeywordTextColor() As Color
		Get
			Return m_TextEditor_KeywordTextColor
		End Get
		Set(ByVal Value As Color)
			m_TextEditor_KeywordTextColor = Value
		End Set
	End Property	  'TextEditor_KeywordTextColor() As Color
	'=========================================================================================
	<Description("Gets and sets the font color of the text editor for comments."), Category("Text Editor")> _
	Public Property TextEditor_CommentTextColor() As Color
		Get
			Return m_TextEditor_CommentTextColor
		End Get
		Set(ByVal Value As Color)
			m_TextEditor_CommentTextColor = Value
		End Set
	End Property	  'TextEditor_CommentTextColor() As Color
	'=========================================================================================
	<Description("Gets and sets the font of the text editor."), Category("Text Editor")> _
	 Public Property TextEditor_Font() As Font
		Get
			Return m_TextEditor_Font
		End Get
		Set(ByVal Value As Font)
			m_TextEditor_Font = Value
			RTF.Font = m_TextEditor_Font
			RTF_Temp.Font = m_TextEditor_Font
		End Set
	End Property	  'TextEditor_Font() As Font
	'=========================================================================================
	Public Overrides Property ContextMenu() As System.Windows.Forms.ContextMenu
		Get
			Return RTF.ContextMenu
		End Get
		Set(ByVal Value As System.Windows.Forms.ContextMenu)
			RTF.ContextMenu = Value
		End Set
	End Property	  'ContextMenu() As System.Windows.Forms.ContextMenu
	'=========================================================================================
	<Description("Gets and sets the border style of the text editor."), Category("Appearance")> _
	Public Property BorderStyle() As System.Windows.Forms.BorderStyle
		Get
			Return Panel_Frame.BorderStyle
		End Get
		Set(ByVal Value As System.Windows.Forms.BorderStyle)
			Panel_Frame.BorderStyle = Value
		End Set
	End Property	  'BorderStyle() As System.Windows.Forms.BorderStyle
	'=========================================================================================
	<Description("Gets and sets the keyword list."), Category("Text Editor")> _
	 Public Property TextEditor_KeywordList() As String
		Get
			Return m_TextEditor_KeywordList
		End Get
		Set(ByVal Value As String)
			m_TextEditor_KeywordList = Value
			RegexKeywordList = Replace(m_TextEditor_KeywordList, m_TextEditor_KeywordDelimiter, "|")
		End Set
	End Property	  'TextEditor_KeywordList() As String
	'=========================================================================================
	<Description("Gets and sets the delimiter for the keyword list."), Category("Text Editor")> _
	 Public Property TextEditor_KeywordDelimiter() As String
		Get
			Return m_TextEditor_KeywordDelimiter
		End Get
		Set(ByVal Value As String)
			m_TextEditor_KeywordDelimiter = Value
		End Set
	End Property	  'TextEditor_KeywordDelimiter() As String
	'=========================================================================================
	<Description("Gets and sets the character used signify a single line comment."), Category("Text Editor")> _
	 Public Property TextEditor_CommentCharacter() As String
		Get
			Return m_TextEditor_CommentCharacter
		End Get
		Set(ByVal Value As String)
			m_TextEditor_CommentCharacter = Value
		End Set
	End Property	  'TextEditor_CommentCharacter() As String
	'=========================================================================================
	<Description("Gets and sets the if code should be colored."), Category("Text Editor")> _
	 Public Property TextEditor_ColorCode() As Boolean
		Get
			Return m_TextEditor_ColorCode
		End Get
		Set(ByVal Value As Boolean)
			m_TextEditor_ColorCode = Value
		End Set
	End Property	  'TextEditor_ColorCode() As Boolean
	'=========================================================================================
	<Description("Gets and sets if URLs should be automatically formated."), Category("Text Editor")> _
	Public Property TextEditor_DetectUrls() As Boolean
		Get
			Return RTF.DetectUrls
		End Get
		Set(ByVal Value As Boolean)
			RTF.DetectUrls = Value
		End Set
	End Property	  'TextEditor_DetectUrls() As Boolean
	'=========================================================================================
	Public Overrides Property Text() As String
		Get
			Return RTF.Text
		End Get
		Set(ByVal Value As String)
			RTF.Text = Value
		End Set
	End Property	  'Text() As String
	'=========================================================================================
	Public WriteOnly Property SetRTF() As String
		Set(ByVal Value As String)
			RTF.Rtf = Value
		End Set
	End Property	  'SetRTF() As String
	'=========================================================================================

#End Region

#Region "Methods"
	'=========================================================================================
	' Methods
	'=========================================================================================
	Public Sub LoadFile(ByVal Path As String)
		RTF.LoadFile(Path)
		' reset our undo history
		UndoHistory = Nothing
	End Sub	  'LoadFile(ByVal Path As String)
	'=========================================================================================
	Public Sub LoadFile(ByVal Path As String, ByVal FileType As System.Windows.Forms.RichTextBoxStreamType)
		RTF.LoadFile(Path, FileType)
		' reset our undo history
		UndoHistory = Nothing
	End Sub	  'LoadFile(ByVal Path As String, ByVal FileType As System.Windows.Forms.RichTextBoxStreamType)
	'=========================================================================================
	Public Sub LoadFile(ByVal Data As System.IO.Stream, ByVal FileType As System.Windows.Forms.RichTextBoxStreamType)
		RTF.LoadFile(Data, FileType)
		' reset our undo history
		UndoHistory = Nothing
	End Sub	  'LoadFile(ByVal Data As System.IO.Stream, ByVal FileType As System.Windows.Forms.RichTextBoxStreamType)
	'=========================================================================================
	Public Sub SaveFile(ByVal Path As String)
		RTF.SaveFile(Path)
	End Sub	  'SaveFile(ByVal Path As String)
	'=========================================================================================
	Public Sub SaveFile(ByVal Path As String, ByVal FileType As System.Windows.Forms.RichTextBoxStreamType)
		RTF.SaveFile(Path, FileType)
	End Sub	  'SaveFile(ByVal Path As String, ByVal FileType As System.Windows.Forms.RichTextBoxStreamType)
	'=========================================================================================
	Public Sub SaveFile(ByVal Data As System.IO.Stream, ByVal FileType As System.Windows.Forms.RichTextBoxStreamType)
		RTF.SaveFile(Data, FileType)
	End Sub	  'SaveFile(ByVal Data As System.IO.Stream, ByVal FileType As System.Windows.Forms.RichTextBoxStreamType)
	'=========================================================================================
	Public Function ConvertToHTML() As String
		RTF_Temp.Clear()
		RTF_Temp.Text = RTF.Text
		ConvertToHTML = modExportToHtml.GetExportCode(True, True, True, RTF_Temp, m_TextEditor_KeywordTextColor, m_TextEditor_CommentTextColor, m_TextEditor_NormalTextColor, m_TextEditor_KeywordList, m_TextEditor_KeywordDelimiter, m_TextEditor_CommentCharacter, m_TextEditor_Font)
	End Function	'ConvertToHTML() As String
	'=========================================================================================
	Public Function ConvertToHTML(ByVal IncludeHeader As Boolean, ByVal IncludeFooter As Boolean, ByVal ColorCode As Boolean) As String
		RTF_Temp.Clear()
		RTF_Temp.Text = RTF.Text
		ConvertToHTML = modExportToHtml.GetExportCode(IncludeHeader, IncludeFooter, ColorCode, RTF_Temp, m_TextEditor_KeywordTextColor, m_TextEditor_CommentTextColor, m_TextEditor_NormalTextColor, m_TextEditor_KeywordList, m_TextEditor_KeywordDelimiter, m_TextEditor_CommentCharacter, m_TextEditor_Font)
	End Function	'ConvertToHTML(ByVal IncludeHeader As Boolean, ByVal IncludeFooter As Boolean, ByVal ColorCode As Boolean) As String
	'=========================================================================================
	Public Sub ExportToHtml(ByVal Path As String)
		RTF_Temp.Clear()
		RTF_Temp.Text = RTF.Text
		modExportToHtml.ExportCode(Path, True, RTF_Temp, m_TextEditor_KeywordTextColor, m_TextEditor_CommentTextColor, m_TextEditor_NormalTextColor, m_TextEditor_KeywordList, m_TextEditor_KeywordDelimiter, m_TextEditor_CommentCharacter, m_TextEditor_Font)
	End Sub	  'ExportToHtml(ByVal Path As String)
	'=========================================================================================
	Public Sub ExportToHtml(ByVal Path As String, ByVal ColorCode As Boolean)
		RTF_Temp.Clear()
		RTF_Temp.Text = RTF.Text
		modExportToHtml.ExportCode(Path, ColorCode, RTF_Temp, m_TextEditor_KeywordTextColor, m_TextEditor_CommentTextColor, m_TextEditor_NormalTextColor, m_TextEditor_KeywordList, m_TextEditor_KeywordDelimiter, m_TextEditor_CommentCharacter, m_TextEditor_Font)
	End Sub	  'ExportToHtml(ByVal Path As String, ByVal ColorCode As Boolean)
	'=========================================================================================
	Public Sub Paste()
		'save the rtf for undo history
		UndoHistory = RTF.Rtf
		UndoHistoryPosition = RTF.SelectionStart

		' if it is html then just paste the text...
		If Clipboard.GetDataObject().GetDataPresent(DataFormats.Html, False) = True Then
			RTF.Paste(DataFormats.GetFormat(DataFormats.Text))
		Else
			RTF.Paste()
		End If
		' if text and we are coloring code then we need to parse it...
		If m_TextEditor_ColorCode = True Then
			If IsPastedText() = True Then ParsePastedText(True)
		End If
		' reset our flag
		PasteFlag = False
	End Sub	  'Paste()
	'=========================================================================================
	Public Sub Paste(ByVal clipFormat As System.Windows.Forms.DataFormats.Format)
		'save the rtf for undo history
		UndoHistory = RTF.Rtf
		UndoHistoryPosition = RTF.SelectionStart

		RTF.Paste(clipFormat)
		' if text and we are coloring code then we need to parse it...
		If m_TextEditor_ColorCode = True Then
			If IsPastedText() = True Then ParsePastedText(True)
		End If
		' reset our flag
		PasteFlag = False
	End Sub	  'Paste(ByVal clipFormat As System.Windows.Forms.DataFormats.Format)
	'=========================================================================================
	Public Sub Undo()
		If UndoHistoryPosition <> -1 Then
			RTF.Rtf = UndoHistory
			RTF.SelectionStart = UndoHistoryPosition
			' are we showing linenumbers...if so update display
			If m_Sidebar_ShowLineNumbers = True Then
				LockUpdate(True)
				Panel_LineNumbers.Invalidate()
				LockUpdate(False)
			End If
			' reset our flag
			UndoFlag = False
			UndoHistoryPosition = -1
		End If
	End Sub	  'Copy()
	'=========================================================================================
	Public Sub Copy()
		RTF.Copy()
	End Sub	  'Copy()
	'=========================================================================================
	Public Sub Cut()
		'save the rtf for undo history
		UndoHistory = RTF.Rtf
		UndoHistoryPosition = RTF.SelectionStart

		RTF.Cut()
		' are we showing linenumbers...if so update display
		If m_Sidebar_ShowLineNumbers = True Then
			LockUpdate(True)
			Panel_LineNumbers.Invalidate()
			LockUpdate(False)
		End If
	End Sub	  'Cut()
	'=========================================================================================
	Public Sub SelectAll()
		RTF.SelectAll()
	End Sub	  'SelectAll()
	'=========================================================================================
	Public Sub SelectText(ByVal start As Integer, ByVal length As Integer)
		RTF.Select(start, length)
	End Sub	  'SelectText(ByVal start As Integer, ByVal length As Integer)
	'=========================================================================================
	Public Sub AppendText(ByVal text As String)
		'save the rtf for undo history
		UndoHistory = RTF.Rtf
		UndoHistoryPosition = RTF.SelectionStart

		RTF.AppendText(text)
		' we added text so if we are coloring code then we need to parse it...
		If m_TextEditor_ColorCode = True Then ParsePastedText(True)
	End Sub	  'AppendText(ByVal text As String)
	'=========================================================================================
	Public Sub Clear()
		'save the rtf for undo history
		UndoHistory = RTF.Rtf
		UndoHistoryPosition = RTF.SelectionStart

		RTF.Clear()
		' are we showing linenumbers...if so update display
		If m_Sidebar_ShowLineNumbers = True Then
			LockUpdate(True)
			Panel_LineNumbers.Invalidate()
			LockUpdate(False)
		End If
	End Sub	  'Clear()
	'=========================================================================================
	Public Function Find(ByVal TextToFind As String) As Integer
		Return RTF.Find(TextToFind)
	End Function	  'Find(ByVal TextToFind As String) As Integer
	'=========================================================================================
	Public Function Find(ByVal TextToFind As String, ByVal Options As System.Windows.Forms.RichTextBoxFinds) As Integer
		Return RTF.Find(TextToFind, Options)
	End Function	  'Find(ByVal TextToFind As String, ByVal Options As System.Windows.Forms.RichTextBoxFinds) As Integer
	'=========================================================================================
	Public Function Find(ByVal TextToFind As String, ByVal StartPosition As Integer, ByVal Options As System.Windows.Forms.RichTextBoxFinds) As Integer
		Return RTF.Find(TextToFind, StartPosition, Options)
	End Function	  'Find(ByVal TextToFind As String, ByVal StartPosition As Integer, ByVal Options As System.Windows.Forms.RichTextBoxFinds) As Integer
	'=========================================================================================
	Public Function Find(ByVal TextToFind As String, ByVal StartPosition As Integer, ByVal EndPosition As Integer, ByVal Options As System.Windows.Forms.RichTextBoxFinds) As Integer
		Return RTF.Find(TextToFind, StartPosition, EndPosition, Options)
	End Function	  'Find(ByVal TextToFind As String, ByVal StartPosition As Integer, ByVal EndPosition As Integer, ByVal Options As System.Windows.Forms.RichTextBoxFinds) As Integer
	'=========================================================================================
	Public Function FirstVisibleLine() As Integer
		Return modRTF_Net.FirstVisibleLine(RTF)
	End Function	  'FirstVisibleLine() As Integer
	'=========================================================================================
	Public Function LineCount() As Integer
		Return modRTF_Net.LineCount(RTF)
	End Function	  'LineCount() As Integer
	'=========================================================================================
	Public Function LineLength() As Integer
		Return modRTF_Net.LineLength(RTF)
	End Function	  'LineLength() As Integer
	'=========================================================================================
	Public Function LineNumber() As Integer
		Return modRTF_Net.LineNumber(RTF)
	End Function	  'LineNumber() As Integer
	'=========================================================================================
	Public Function LineStartPosition() As Integer
		Return modRTF_Net.LineStartPosition(RTF)
	End Function	  'LineStartPosition() As Integer
	'=========================================================================================
	Public Function LineText() As String
		Return modRTF_Net.LineText(RTF)
	End Function	  'LineText() As String
	'=========================================================================================
	Public Sub GoToLine(ByVal LineNumber As Integer, ByVal LinePosition As LinePosition)
		modRTF_Net.GoToLine(RTF, LineNumber, LinePosition)
	End Sub	  'GoToLine(ByVal LineNumber As Integer, ByVal LinePosition As LinePosition)
	'=========================================================================================
	Public Sub GoToLine(ByVal LineNumber As Integer)
		modRTF_Net.GoToLine(RTF, LineNumber)
	End Sub	  'GoToLine(ByVal LineNumber As Integer)
	'=========================================================================================
	Public Sub RecolorCode()
		' force a recolor of all code
		If m_TextEditor_ColorCode = True Then
			LockUpdate(True)
			' save where we are
			Dim TempPosition As Integer = RTF.SelectionStart
			' set current position to last character
			CurrentPosition = Len(RTF.Text)
			' set start as first character
			StartPosition = 1
			' parse the text
			ParsePastedText(False)
			' put us back where we were
			RTF.SelectionStart = TempPosition
			LockUpdate(False)
		End If
	End Sub	  'RecolorCode()
	'=========================================================================================
	Public Sub ShowFindDialog()
		' show the find dialog
		Dim FindReplaceForm As New frmFindReplace()
		RTF.HideSelection = False
		With FindReplaceForm
			.TopMost = True
			.DialogType = frmFindReplace.DialogTypeValue.Find
			.OwnerCodeBox = Me
			.Show()
			.txtFind.Focus()
		End With
	End Sub	  'ShowFindDialog()
	'=========================================================================================
	Public Sub ShowFindReplaceDialog()
		' show the find and replace dialog
		Dim FindReplaceForm As New frmFindReplace()
		RTF.HideSelection = False
		With FindReplaceForm
			.TopMost = True
			.DialogType = frmFindReplace.DialogTypeValue.Replace
			.OwnerCodeBox = Me
			.Show()
			.txtFindWhat.Focus()
		End With
	End Sub	  'ShowFindReplaceDialog()
	'=========================================================================================

#End Region

#Region "Hidden Properties"
	'=========================================================================================
	'Hidden Properties
	'=========================================================================================
	<Browsable(False)> _
	Public Overrides Property Font() As System.Drawing.Font
		Get
			Return MyBase.Font
		End Get
		Set(ByVal Value As System.Drawing.Font)
			'do nothing
		End Set
	End Property	  'Font() As System.Drawing.Font
	'=========================================================================================
	<Browsable(False)> _
	  Public Overrides Property ForeColor() As System.Drawing.Color
		Get
			Return MyBase.ForeColor
		End Get
		Set(ByVal Value As System.Drawing.Color)
			'do nothing
		End Set
	End Property	  'ForeColor() As System.Drawing.Color
	'=========================================================================================
	<Browsable(False)> _
	Public Overrides Property BackColor() As System.Drawing.Color
		Get
			Return MyBase.BackColor
		End Get
		Set(ByVal Value As System.Drawing.Color)
			'do nothing
		End Set
	End Property	  'BackColor() As System.Drawing.Color
	'=========================================================================================
	<Browsable(False)> _
	Public Overrides Property BackgroundImage() As System.Drawing.Image
		Get
			Return MyBase.BackgroundImage
		End Get
		Set(ByVal Value As System.Drawing.Image)
			'do nothing
		End Set
	End Property	  'BackgroundImage() As System.Drawing.Image
	'=========================================================================================
	<Browsable(False)> _
	  Public Property SelectedText() As String
		Get
			Return RTF.SelectedText
		End Get
		Set(ByVal Value As String)
			RTF.SelectedText = Value
		End Set
	End Property	  'SelectedText() As String
	'=========================================================================================
	<Browsable(False)> _
	Public Property SelectedRTF() As String
		Get
			Return RTF.SelectedRtf
		End Get
		Set(ByVal Value As String)
			RTF.SelectedRtf = Value
		End Set
	End Property	  'SelectedRTF() As String
	'=========================================================================================
#End Region

#Region "Functions and Subs"
	'=========================================================================================
	'Functions and Subs
	'=========================================================================================
	Private Sub DrawLineNumber(ByVal g As Graphics, ByVal LineNumber As Integer)
		' routine to draw the sidebar and numbers for line numbering
		Dim Y As Integer = 1
		Dim RTFLineCount As Integer = modRTF_Net.LineCount(RTF)
		'rtf line numbers are zero based so set to start at one
		LineNumber = LineNumber + 1
		g.Clear(m_Sidebar_BackGroundColor)
		Do
			If LineNumber <= RTFLineCount Then
				g.DrawString(LineNumber.ToString(), Panel_LineNumbers.Font, m_Sidebar_Brush, 3, Y)
			Else
				g.DrawString("", Panel_LineNumbers.Font, m_Sidebar_Brush, 3, Y)
			End If
			LineNumber = LineNumber + 1
			Y = Y + Panel_LineNumbers.Font.Height + 1
			If Y > Panel_LineNumbers.DisplayRectangle.Height - 15 Then Exit Do
		Loop
	End Sub	  'DrawLineNumber(ByVal g As Graphics, ByVal intLine As Integer)
	'=========================================================================================
	Private Sub ParseText(ByVal Text As String)
		'parse and color the code
		Dim ChangeFlag As Boolean
		Dim CurrentChr As String = ""
		Dim Counter As Integer = 0
		Dim FoundAt As Integer = 0
		Dim Length As Integer = 0
		Dim QuoteFlag As Boolean = False
		Dim CommentFlag As Boolean = False
		Dim RegexPattern As String = "\b(" & RegexKeywordList & ")\s*\b"
		Dim Match As Match
		Dim TempString As String

		RTF_Temp.Clear()
		RTF_Temp.Text = Text
		LockUpdate(True)
		With RTF_Temp
			' look for keywords
			For Each Match In Regex.Matches(.Text, RegexPattern, RegexOptions.Multiline)
				.Select(Match.Index, Match.Length)
				.SelectionColor = m_TextEditor_KeywordTextColor
				ChangeFlag = True
			Next Match

			' look for quoted words
			RegexPattern = """+.*""+"
			For Each Match In Regex.Matches(.Text, RegexPattern, RegexOptions.Singleline)
				.Select(Match.Index, Match.Length)
				.SelectionColor = m_TextEditor_NormalTextColor
				ChangeFlag = True
				QuoteFlag = True
			Next Match

			'check for comments
			FoundAt = InStr(.Text, m_TextEditor_CommentCharacter)
			If FoundAt > 0 Then
				If QuoteFlag = False Then
					' found a comment but no quotes so don't need special processing
					Length = Len(.Text)
					.Select(FoundAt - 1, Length)
					.SelectionColor = m_TextEditor_CommentTextColor
					ChangeFlag = True
				Else
					' we have quotes so we need to see if the comment character is contained in quotes or actually a comment
					' reset our flags
					QuoteFlag = False
					CommentFlag = False
					'go through one character at a time to determine if contained in quotes or comment
					For Counter = 1 To Len(.Text)
						CurrentChr = Mid(.Text, Counter, 1)
						If CurrentChr = Chr(34) Then
							' found a quote
							QuoteFlag = Not QuoteFlag
						Else
							' allows multi character comment delimeters
							If CurrentChr & Mid(.Text, Counter, Len(m_TextEditor_CommentCharacter) - 1) = m_TextEditor_CommentCharacter Then
								If QuoteFlag = False Then
									' found our comment and not contained in quotes
									.Select(Counter - 1, Len(.Text))
									.SelectionColor = m_TextEditor_CommentTextColor
									ChangeFlag = True
								End If
							End If
						End If
					Next Counter
				End If
			End If
		End With

		' lets put the new parsed text back...
		RTF_Temp.SelectAll()
		' no keywords, no comment, no quotes so normal text so force normal text color
		If ChangeFlag = False Then
			RTF_Temp.SelectAll()
			RTF_Temp.SelectionColor = m_TextEditor_NormalTextColor
		End If
		RTF.Select(modRTF_Net.LineStartPosition(RTF), modRTF_Net.LineLength(RTF))
		RTF.SelectedRtf = RTF_Temp.SelectedRtf

		LockUpdate(False)
		'set as being not dirty since as of now we have parsed it
		RTF.Modified = False
	End Sub	  'ParseText(ByVal Text As String)
	'=========================================================================================
	Private Function IsPastedText() As Boolean
		If Clipboard.GetDataObject().GetDataPresent(DataFormats.Bitmap, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.Dib, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.Dif, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.EnhancedMetafile, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.FileDrop, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.MetafilePict, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.Palette, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.PenData, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.Riff, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.Serializable, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.SymbolicLink, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.Tiff, False) = True Or _
		Clipboard.GetDataObject().GetDataPresent(DataFormats.WaveAudio, False) = True Then
			IsPastedText = False
		Else
			IsPastedText = True
		End If
	End Function	  'IsPastedText() As Boolean
	'=========================================================================================
	Private Sub ParsePastedText(ByVal UpdatePositionVariables As Boolean)
		' something was pasted so could be multiplelines...
		Dim StartLineNumber As Integer
		Dim CurrentLineNumber As Integer
		' lock our updates
		LockUpdate(True)
		' do we need to update our start and current position variables
		If UpdatePositionVariables = True Then
			' get our last cursor position and save current position
			StartPosition = CurrentPosition
			CurrentPosition = RTF.SelectionStart
		End If
		' find out the starting linenumber
		RTF.SelectionStart = StartPosition
		StartLineNumber = modRTF_Net.LineNumber(RTF)
		' find out what linenumber we are on now
		RTF.SelectionStart = CurrentPosition
		CurrentLineNumber = modRTF_Net.LineNumber(RTF)
		' are we on different lines...
		If CurrentLineNumber > StartLineNumber Then
			Dim Counter As Integer
			For Counter = StartLineNumber To CurrentLineNumber
				' only working with one line at a time...need to increase by one because lines are zero based
				modRTF_Net.GoToLine(RTF, Counter + 1, modRTF_Net.LinePosition.LinePosition_End)
				StartPosition = RTF.SelectionStart
				ParseText(modRTF_Net.LineText(RTF))
				RTF.SelectionStart = StartPosition
				RTF.SelectionColor = m_TextEditor_NormalTextColor
			Next Counter
			' put us back where we should be
			RTF.SelectionStart = CurrentPosition
		Else
			' only working with current line
			ParseText(modRTF_Net.LineText(RTF))
			RTF.SelectionStart = CurrentPosition
			RTF.SelectionColor = m_TextEditor_NormalTextColor
		End If
		' unlock our update
		LockUpdate(False)
	End Sub	  'ParsePastedText(ByVal UpdatePositionVariables As Boolean)
	'=========================================================================================
#End Region

End Class


