'=====================================================================================
'  modRTF_Net
'  color syntax control helper module...used to work with the rtf control
'=====================================================================================
'  Created By: Marc Cramer
'  Published Date: 1/16/2003
'  Legal Copyright: Marc Cramer  1/16/2003
'=====================================================================================

Module modRTF_Net

	Public Enum LinePosition As Byte
		LinePosition_End = 0
		LinePosition_Front = 1
	End Enum

	Private Const EM_LINEINDEX As Short = &HBBS
	Private Const EM_LINELENGTH As Short = &HC1S
	Private Const EM_LINEFROMCHAR As Short = &HC9S
	Private Const EM_GETLINECOUNT As Short = &HBAS
	Private Const EM_GETFIRSTVISIBLELINE As Short = &HCES

	Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Integer
	'=========================================================================================
	Public ReadOnly Property LineNumber(ByVal rtf As RichTextBox) As Integer
		Get
			' Returns a number indicating which line the cursor is currently on
			Return SendMessage(rtf.Handle.ToInt32, EM_LINEFROMCHAR, -1, 0)
		End Get
	End Property
	'=========================================================================================
	Public ReadOnly Property LineText(ByVal rtf As RichTextBox) As String
		'Returns the line of text at a given line number
		Get
			Try
				Return rtf.Lines.GetValue(LineNumber(rtf))
			Catch e As Exception
				Return ""
			End Try
		End Get
	End Property	  'LineText(ByVal rtf As RichTextBox) As String
	'=========================================================================================
	Public ReadOnly Property LineStartPosition(ByVal rtf As RichTextBox) As Integer
		Get
			' Returns the character index that starts this line
			Return SendMessage(rtf.Handle.ToInt32, EM_LINEINDEX, LineNumber(rtf), 0)
		End Get
	End Property	'LineStartPosition(rtf As RichTextBox, ByVal LineIndex As Long) As Long
	'=========================================================================================
	Public ReadOnly Property LineLength(ByVal rtf As RichTextBox) As Integer
		Get
			' Returns the length of the line at the given character index
			Return SendMessage(rtf.Handle.ToInt32, EM_LINELENGTH, rtf.SelectionStart, 0)
		End Get
	End Property	'LineLength(ByVal rtf As RichTextBox) As Integer
	'=========================================================================================
	Public ReadOnly Property LineCount(ByVal rtf As RichTextBox) As Integer
		Get
			' Return the line count
			Return SendMessage(rtf.Handle.ToInt32, EM_GETLINECOUNT, 0, 0)
		End Get
	End Property	'LineCount(rtf As RichTextBox) As Long
	'=========================================================================================
	Public ReadOnly Property FirstVisibleLine(ByVal rtf As RichTextBox) As Integer
		Get
			' Returns a number indicating the first visible line
			Return SendMessage(rtf.Handle.ToInt32, EM_GETFIRSTVISIBLELINE, 0, 0)
		End Get
	End Property	'FirstVisibleLine(ByVal rtf As RichTextBox) As Integer
	'=========================================================================================
	Public Sub GoToLine(ByVal rtf As RichTextBox, ByVal LineNumber As Integer, Optional ByVal LinePosition As LinePosition = LinePosition.LinePosition_End)
		' routine to go to a selected line
		If IsNumeric(LineNumber) Then
			Dim rtf_LineCount As Integer = LineCount(rtf)
			If LineNumber > rtf_LineCount Or LineNumber < 1 Then
				MessageBox.Show("Not a valid line number", "Not Valid", MessageBoxButtons.OK, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly)
			Else
				rtf.SelectionStart = SendMessage(rtf.Handle.ToInt32, EM_LINEINDEX, LineNumber - 1, 0)
				If LinePosition = LinePosition.LinePosition_End Then rtf.SelectionStart = rtf.SelectionStart + LineLength(rtf)
			End If
		Else
			MessageBox.Show("Not a valid line number", "Not Valid", MessageBoxButtons.OK, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly)
		End If
		rtf.Focus()
	End Sub	  'GoToLine(ByVal rtf As RichTextBox, ByVal LineNumber As Integer, Optional ByVal LinePosition As LinePosition = LinePosition.LinePosition_End)
	'=========================================================================================
	Public ReadOnly Property WordCount(ByVal rtf As RichTextBox) As Integer
		' routine to get word count
		Get
			Dim Counter As Integer
			Dim Match As System.Text.RegularExpressions.Match
			For Each Match In System.Text.RegularExpressions.Regex.Matches(rtf.Text, "\w+")
				Counter = Counter + 1
				'System.Diagnostics.Debug.WriteLine(Match.Value)
			Next
			Return Counter
		End Get
	End Property	  'WordCount(ByVal rtf As RichTextBox) As Integer
	'=========================================================================================
End Module
